package java.nio;

import sun.nio.ch.DirectBuffer;

class DirectLongBufferRS extends DirectLongBufferS implements DirectBuffer
{
    DirectLongBufferRS(DirectBuffer directBuffer, int n, int n2, int n3, int n4, int n5) {
        super(directBuffer, n, n2, n3, n4, n5);
    }
    
    @Override
    public LongBuffer slice() {
        int position = this.position();
        int limit = this.limit();
        int n = (position <= limit) ? (limit - position) : 0;
        int n2 = position << 3;
        assert n2 >= 0;
        return new DirectLongBufferRS(this, -1, 0, n, n, n2);
    }
    
    @Override
    public LongBuffer duplicate() {
        return new DirectLongBufferRS(this, this.markValue(), this.position(), this.limit(), this.capacity(), 0);
    }
    
    @Override
    public LongBuffer asReadOnlyBuffer() {
        return this.duplicate();
    }
    
    @Override
    public LongBuffer put(long n) {
        throw new ReadOnlyBufferException();
    }
    
    @Override
    public LongBuffer put(int n, long n2) {
        throw new ReadOnlyBufferException();
    }
    
    @Override
    public LongBuffer put(LongBuffer longBuffer) {
        throw new ReadOnlyBufferException();
    }
    
    @Override
    public LongBuffer put(long[] array, int n, int n2) {
        throw new ReadOnlyBufferException();
    }
    
    @Override
    public LongBuffer compact() {
        throw new ReadOnlyBufferException();
    }
    
    @Override
    public boolean isDirect() {
        return true;
    }
    
    @Override
    public boolean isReadOnly() {
        return true;
    }
    
    @Override
    public ByteOrder order() {
        return (ByteOrder.nativeOrder() == ByteOrder.BIG_ENDIAN) ? ByteOrder.LITTLE_ENDIAN : ByteOrder.BIG_ENDIAN;
    }
}
